Updated: 2017-01-20 00:52 EST

1 Due Date and Deliverables

Do not print this assignment on paper!

WARNING: Some inattentive students upload Assignment #11 into the Assignment #10 upload area. Don’t make that mistake! Be exact.

2 Purpose and Background

This is a BONUS assignment for extra credit. It is optional.

This assignment is based on your weekly Class Notes and covers these topics:

  1. Create a useful shell script to isolate a column of standard input.
  2. Extract an ASCII file buried inside a series of compressed tar files.
  3. Practise with a Linux text editor.

3 How to complete this Assignment

For full marks, follow these directions exactly:

  1. These tasks must be done in your account via Remote Login to the Course Linux Server.

  2. Do the tasks in order, from top to bottom. Do not skip steps. Most tasks are independent, but some depend on successful completion of a previous task.

  3. READ ALL THE WORDS in each task before you begin the task, especially all the Hints and links.

  4. Verify your own work before running the Checking Program. You won’t have a Checking Program at your job interview and the Checking Program is not guaranteed to check everything.

  5. Run the Checking Program at the end of the task to grade your work and help you find some of your errors. A perfect mark from the Checking Program does not mean your answers are correct.

  6. When you are done with this Assignment, submit the output of the Checking Program to Blackboard before the due date, following the directions given at the end of this Assignment.

This is a BONUS assignment for extra credit. It is optional.

3.1 Notes on doing assignment work

  1. You can use the Checking Program to check your work after you have completed each task.

    Most task sections below require you to finish the whole task section before running the Checking Program. You may not always be able to run the Checking Program successfully in the middle of a task or after every single task sub-step. The assignment tells you where you can safely check your work.

  2. You will create file system structure in your CLS home directory containing various directories and files. When you are finished the tasks, leave the files and directories in place on the CLS as part of your deliverables for your instructor to verify.

    Assignments may be re-marked at any time on the CLS; you must have your term work available on the CLS right until term end. Do not delete any assignment work until after the term is over!

  3. You can modify your work and check it with the Checking Program as often as you like before you submit your final mark to Blackboard. You can upload your marks to Blackboard as many times as you like before the due date. Partial marks are accepted.

  4. Your instructor will also mark on the due date the work you do in your account on the CLS. Leave all your work on the CLS and do not modify it after you have submitted your final mark to Blackboard.

3.2 Searching the course notes on the CLS

All course notes are available on the Internet and also on the CLS. You can learn about how to read and search these CLS files using the command line on the CLS under the heading Copies of the CST8207 course notes near the bottom of the page Course Linux Server.

3.3 The Source Directory

All references to the Source Directory below are to the CLS directory ~idallen/cst8207/16f/assignment12/ and that name starts with a tilde character ~ followed by a user name with no intervening slash. The leading tilde indicates to the shell that the pathname starts with the HOME directory of the account idallen (seven letters).

You do not have permission to list the names of all the files in the Source Directory, but you can access any files whose names you already know.

3.4 Properties of all scripts

  1. Most of the tasks below ask you to write a small executable shell script, based on the lecture notes and slides. None of the scripts need complex Boolean expressions (“||” or “&&” or -a or -o); they are all simple scripts with simple conditional logic.

  2. Each script below must begin with the Standard Script Header you used for your previous script assignments. See the class notes.

  3. Though the header is executable code, in the descriptions below we don’t count those lines, or any comment or blank lines, in the size of the script. We only count the new lines of code that you write.

For example, a “one-line script” is really several lines of header, a blank line, a block of several comment lines that Document Your Script, another blank line, and then your one line of actual script code. The description below calls this a one line script, even though it may contain a dozen lines.

  1. Make sure that your script file is executable, so that it can be executed as ./scriptname.sh from the shell command line.

  2. Build up each script by adding a few lines and testing what you have added; don’t write the whole thing and try to debug it!

  3. Run the given example tests on your scripts to make sure they work. Sample output for each of the scripts is given, so that you may check your work as you proceed.

  4. Make sure your script handles all of the sample inputs given, especially the inputs containing shell metacharacters. (System crackers often attack your system using special characters as input.)

  5. The examples below do not fully test your script; you will need to try other examples to make sure your scripts work properly for all possible inputs, especially inputs with blanks and shell meta-characters.

  6. Remember to double quote all variable expansions to prevent GLOB and blank expansion that can cause syntax errors and other unwanted problems in your script.

  7. Error messages must follow the Good Error Message format given below.

  8. If you are having problems with your script and are getting error messages from the shell, review possible Script Problems.

4 Tasks

For full marks, follow these task directions below exactly as written. READ ALL THE WORDS to work effectively and not waste your time.

  1. Complete the Tasks listed below, in order, from top to bottom.
  2. Do not skip task steps. (But you can do the individual scripts in any order.)
  3. These tasks must be done in your account on the Course Linux Server.
  4. Verify your own work before running the Checking Program.
  5. Run the Checking Program to help you find errors and grade your work.
  6. Submit the grading output of the Checking Program to Blackboard before the due date.

Your instructor will also mark on the due date the work you do in your account on the CLS. Leave all your work on the CLS and do not modify it. Do not delete any assignment work from the CLS until after the course is over.

4.1 Set Up – The Base Directory on the CLS

You must keep a list of command names used each week and write down what each command does, as described in the [List of Commands You Should Know]. Without that list to remind you what command names to use, you will find assignments very difficult.

  1. Do a Remote Login to the Course Linux Server (CLS) from any existing computer, using the host name appropriate for whether you are on-campus or off-campus. All work in this assignment must be done on the CLS.

  2. Base Directory: Make the CLS directory named ~/CST8207-16F/Assignments/assignment12, in which you will create the files and scripts resulting from the following tasks. (You do not have to create any directories that you have already created in a previous assignment.) Spelling and capitalization must be exactly as shown:

check

  1. Create the check symbolic link needed to run the Checking Program, as described in the section Checking Program below.

This assignment12 directory is called the Base Directory for most pathnames in this assignment. Store your files and answers in this Base Directory, not in your HOME directory or anywhere else.

Use the symbolic link to run the Checking Program to verify your work so far.

4.1.1 Checking only one of your scripts

Normally the Checking Program checks all the scripts. This can be slow if you are only interested in the check output for one script that you are working on. You can check just one or more individual scripts by giving the script names as arguments to the Checking Program:

$ ./check acol1.sh                      # only check this script
$ ./check acol1.sh acolNF.sh            # only check these two scripts

Do not submit for marking the output of checking only a few scripts!

4.2 awk wrapper script: extracting a column of input

Recall in lecture that we used used the awk program to extract the first space-delimited column of an input stream. We will develop a script named acol (Awk COLumn) that extracts any column of input.

Review Properties of all Scripts, above.

You need to understand Shell Scripts and Control Structures to do these scripts.

The first four scripts have no error checking code. Only the final acol.sh script needs to have full error checking.

4.2.1 acol1.sh

Create a one-line script named acol1.sh that uses awk to read its standard input and extract the first column, exactly as used in the lecture notes.

Make sure all the examples below work before you run the checking program! Examples:

$ echo a b c | ./acol1.sh
a

$ date
Sun Dec  4 02:11:41 EST 2016
$ date | ./acol1.sh
Sun

$ last | ./acol1.sh
idallen
idallen
kelleyt
donnelr
[...etc...]

Add comments to Document Your Script.

Check your work so far using the checking program symlink.

4.2.2 acol2.sh

Create a one-line script named acol2.sh that uses awk to read its standard input and extract the second column of input.

Make sure all the examples below work before you run the checking program! Examples:

$ echo a b c | ./acol2.sh
b

$ date
Sun Dec  4 02:11:41 EST 2016
$ date | ./acol2.sh
Dec

$ last | ./acol2.sh
pts/9
pts/14
pts/50
pts/50
[...etc...]

Add comments to Document Your Script.

Check your work so far using the checking program symlink.

4.2.3 acolNF.sh

Create a one-line script named acolNF.sh that uses awk to read its standard input and extract the last (NF) column of input.

Make sure all the examples below work before you run the checking program! Examples:

$ echo a b c | ./acolNF.sh
c

$ echo a b d e f g h i j | ./acolNF.sh
j

$ date
Sun Dec  4 02:11:41 EST 2016
$ date | ./acolNF.sh
2016

$ last | ./acolNF.sh
(00:31)
(02:11)
(02:02)
(00:01)
[...etc...]

Add comments to Document Your Script.

Check your work so far using the checking program symlink.

4.2.4 acolnew.sh

It should be clear that having a separate script for every possible number of columns is not a good thing. Let’s write one script that takes as its only argument the column number we want awk to print.

Create a one-line script named acolnew.sh that uses awk to read its standard input and extract the column of input given as an argument on the command line.

This new one-line script is a very small modification of your previous one-line scripts; you only need to change about a half-dozen characters in the one line to make it work.

Make sure all the examples below work before you run the checking program! Examples:

$ echo a b c d e f | ./acolnew.sh 1
a

$ echo a b c d e f | ./acolnew.sh 2
b

$ echo a b c d e f | ./acolnew.sh NF
f

The script takes a single argument that is either a number (e.g. 1, 2, etc.) or the string NF and substitutes that argument directly into the awk command line inside the script as the column to print, instead of using the previous hard-coded column number 1, 2, or NF that you used in the three previous scripts.

Hint: Instead of hard-coding the column number in the awk command line, as you did in the above three previous scripts, use the first script argument variable instead of the hard-coded number. You will need to adjust the Quoting around the awk command arguments to allow the shell argument variable to be expanded by the shell but still keep hidden from the shell the $ used by awk to select the column number. You cannot use the awk -v option here.

The new one-line script is a simple modification of your previous one-line script: it is still a one-line script; it does not yet do any input checking or argument processing. If you don’t supply an argument, or you pass something that awk doesn’t understand, you will get an error from the shell or from awk – this is expected:

# examples of errors when script or awk gets bad input:

$ echo a b c d e f | ./acolnew.sh
./acolnew.sh: 8: ./acolnew.sh: 1: parameter not set

$ echo a b c d e f | ./acolnew.sh ''
awk: { print $ }
awk:           ^ syntax error

$ echo a b c d e f | ./acolnew.sh ' '
awk: { print $  }
awk:            ^ syntax error

$ echo a b c d e f | ./acolnew.sh @
awk: { print $@ }
awk:          ^ invalid char '@' in expression

If you supply more than one argument, the script won’t detect the error and will simply ignore the extra arguments – this is okay for this prototype script:

$ echo a b c | ./acolnew.sh NF these arguments after NF are ignored
c

This one-line script does not validate its input, so it gives cryptic errors if the argument is incorrect and it does not warn you if you give too many arguments. This is not a production-quality script. We will fix it in the next step.

Add comments to Document Your Script.

Check your work so far using the checking program symlink.

4.2.5 acol.sh

Copy acolnew.sh to acol.sh and add full input validation to the new script.

The new script must check to make sure it has exactly one input argument and do validation of that one argument before using it with awk to print the given column number. The only valid input allowed must be an integer from 1 to 231-1, or the string NF.

You do not need to change the awk line in your script at all. You only need to add input validation to the script, before calling awk. The input validation will cause the script to exit if the input is bad, so that awk doesn’t process bad input.

  • Your script should enforce the “only one argument” requirement. Print both a Good Error Message and Usage Message on stderr and exit with a bad error status if the number of arguments is not exactly one.

  • Also print an error and Usage message and exit if the one argument is equal to the empty string (''), or if it is not all-digits or NF.

  • Also print an error and Usage message and exit if a numeric argument contains more than 15 digits. (The built-in test command can’t test very large integers!) Hint: You can do this check with a GLOB pattern.

  • Also print an error and Usage message and exit if a numeric argument is zero or greater than or equal to 231. (The awk program can’t handle huge column numbers: awk: fatal: attempt to access field -2147483648)

Make sure all the examples below work before you run the checking program! Examples:

$ echo a b c | ./acol.sh
...error message about wrong number of arguments prints here...
...usage message prints here...
$ echo $?
1

$ echo a b c | ./acol.sh 1 2 3 a b c >out
...error message about wrong number of arguments prints here...
...usage message prints here...
$ echo $?
1

$ echo a b c | ./acol.sh ''
...error message about empty argument prints here...
...usage message prints here...
$ echo $?
1

$ echo a b c | ./acol.sh ' '
...error message about non-digit, non-NF argument prints here...
...usage message prints here...
$ echo $?
1

$ echo a b c | ./acol.sh '*'
...error message about non-digit, non-NF argument prints here...
...usage message prints here...
$ echo $?
1

$ echo a b c | ./acol.sh 0000000000123456           # 16 digits
...error message about field number being more than 15 digits...
...usage message prints here...
$ echo $?
1

$ echo a b c | ./acol.sh 2147483648                 # 2**31
...error message about field number being >= 2**31...
...usage message prints here...
$ echo $?
1

$ echo a b c | ./acol.sh 0
...error message about field number being zero...
...usage message prints here...
$ echo $?
1

$ echo a b c | ./acol.sh 1
a
$ echo $?
0

$ echo a b c | ./acol.sh NF
c
$ echo $?
0

$ echo a b c | ./acol.sh 2147483647                 # 2**31 - 1

$ echo $?
0

$ echo a b c | ./acol.sh 000000000000002            # 15 digits
b
$ echo $?
0

Add comments to Document Your Script.

Check your work so far using the checking program symlink.

Extra Work: The awk program interprets numbers with leading zeroes as octal (base 8), which produces unexpected results:

 $ seq -s  ' ' 1 10
 1 2 3 4 5 6 7 8 9 10
 $ seq -s  ' ' 1 10 | ./acol.sh 10
 10
 $ seq -s  ' ' 1 10 | ./acol.sh 010
 8

Find a way to remove leading zeroes before the number gets passed to awk.

4.3 File extraction puzzle – puzzle.txt

You need to understand Tar and Gzip and Permissions to do this task.

puzzle.txt

  1. After you have run the Checking Program at least once, you will find created for you in the Source Directory a puzzle file named with your userid puzzle/abcd0001.mystery (where abcd0001 is replaced by your own userid). This file contains many layers of compression and tar archiving.

    Extract the ASCII text file from deep inside this puzzle file and save the ASCII text as file puzzle.txt in your Base Directory.

    Hints: Repeatedly unpack the compression and tar archiving until you find an ASCII text file. I demonstrated this example in class after the lecture showing you the tar command – see your class notes. The file command will be helpful to decode the nested layers of the puzzle.

Check your work so far using the checking program symlink.

4.4 When you are done

That is all the tasks you need to do.

Read your CLS Linux EMail and remove any messages that may be waiting. See Reading EMail for help.

Check your work a final time using the Checking Program below and save the standard output of that program into a file as described below. Submit that file (and only that one file) to Blackboard following the directions below.

When you are done, log out of the CLS before you close your laptop or close the PuTTY window, by using the shell exit command:

$ exit

5 Document Your Script

You must document your script with comment lines before you submit it. Script comment lines start with the comment or hashtag character # and extend to the end of the line. You can (and must) use more than one comment line in your script.

Add at least five (or more) comment lines to each script containing the following five types of information, in the following order:

  1. The assignment number and name (copied exactly from the top of the assignment page).
  2. The question number and script name, e.g. 4.2.1 acol1.sh
  3. Your name, your 9-digit student number, and your Algonquin email address.
  4. The one-line Signing Key for this script file, generated by running the Checking Program with a first argument of -s and a second argument of the script name, e.g. ./check -s acol1.sh The Signing Key comment line must start with # KEY: and will be about 70 characters long.
  5. A brief summary in your own words of what the script does. The summary can be one or more comment lines long. The comments will be read and marked by your professor after you have submitted your lab; the Checking Program cannot evaluate the quality of what you write. Poor comments means poor marks.

Obey these rules for your script comments:

  1. Use your own words to describe your script; don’t copy mine. Your description might document any special features that are worth noting and remembering, such as the use of 1>&2 to write messages to standard error instead of standard output.
  2. The block of five or more comment lines must appear below the standard script header and above your actual script code.
  3. A blank line must separate the block of comment lines from the script header above it and another blank line must separate the block of comments from the script code below it.
  4. Each comment line should be less than 80 characters long, to fit on a standard terminal screen nicely. Use multiple comment lines starting with # rather than making one huge long comment line.
  5. The comments will be read and marked by your professor after you have submitted your lab; the Checking Program cannot evaluate the quality of the documentation that you write. Bad comments means bad marks.

Here is a sample comment block for a hypothetical assignment number 99:

# Assignment 99 This is a Sample Comment Block
# 1.2 foo.sh
# Ian Allen 123456789 abcd0001@algonquinlive.com
# KEY: ==wMwATMskemnackve2NxIDO0N3Ygg2cuMHduVWb1dmchByN4YTOxcTO1QTM
# This is a script that demonstrates how to frob the widjet.
# If there are no widjets to frob, the script prints an
# error message end exits with status 2.  Otherwise exit zero.

Make sure you do the correct placement of the comment block in the script file, as described above!

6 Good Error Messages and Usage Messages

Good shell script error messages must obey these four rules:

  1. Error messages must appear on standard error, not standard output. You can use the shell syntax 1>&2 to send to stderr any output normally destined for stdout. See the examples below.
    • Usually 1>&2 is used on echo statements, to send the text to standard error instead of standard output.
  2. Must contain the name of the program that is issuing the message (from $0).
    • Do not put the name of the script into the script (except in the submission comment line); always use $0.
  3. Must state what kind of input was expected (e.g. expecting one file name).
    • Do not say only “expecting one argument”, since that doesn’t say what kind of argument is needed. Be explicit about what is expected. Avoid using the vague word “argument”.
  4. Must display what input the user actually entered (e.g. found 3 (a b c)
    • Display both the number of arguments $# and their values $*.

Never say just missing argument or illegal input or invalid input or too many. Always specify exactly what is needed and how many is “too many” or “too few”. Here are examples:

echo 1>&2 "$0: Expecting 3 file names; found $# ($*)"
echo 1>&2 "$0: Student age '$student_age' is not between $min_age and $max_age"
echo 1>&2 "$0: Modify days '$moddays' must be greater than zero"
echo 1>&2 "$0: File '$file' does not exist; expecting accounting file"

Put quotes around anything entered by a user, otherwise your error messages may be confusing. Compare these example messages without and with quotes around the user input file name:

$ ./total.sh still
./total.sh: File still does not exist; expecting accounting file
Usage: ./total.sh account_file

$ ./total.sh still
./total.sh: File 'still' does not exist; expecting accounting file
Usage: ./total.sh account_file

6.1 The Usage Message

After detecting an error, the usual thing to do is print a Good Error Message explaining the error, followed by a Usage message telling how to use the script, then exit the script with a non-zero return code. Don’t keep processing bad data!

The Usage message gives the syntax for correctly using the script, using man page syntax to indicate optional and repeated arguments, e.g.:

Usage: ./script.sh [ first_line [ last_line ] ]
Usage: ./script.sh filename...

The name of the script is output using the $0 variable. Do not hard-code the name of a script inside the script.

7 Checking, Marking, and Submitting your Work

Summary: Do some tasks, then run the Checking Program to verify your work as you go. You can run the Checking Program as often as you want. When you have the best mark, upload the single file that is the output of the Checking Program to Blackboard.

Since I also do manual marking of student assignments, your final mark may not be the same as the mark submitted using the current version of the Checking Program. I do not guarantee that any version of the Checking Program will find all the errors in your work. Complete your assignments according to the specifications, not according to the incomplete set of the mistakes detected by the Checking Program.

check

  1. There is a Checking Program named assignment12check in the Source Directory on the CLS. You can execute this program by typing its (long) pathname into the shell as a command name and paginating the (often long) output using less:

    $ ~idallen/cst8207/16f/assignment12/assignment12check | less

    Create a symbolic link named check in your Base Directory that links to the Checking Program in the Source Directory, as you did in a previous assignment. Use the symlink to check your work:

    $ ./check | less

Checking only one of your scripts

Normally the Checking Program checks all the scripts. This can be slow if you are only interested in the check output for one script that you are working on. You can check just one or more individual scripts by giving the script names as arguments to the Checking Program:

$ ./check acol1.sh                      # only check this script
$ ./check acol1.sh acolNF.sh            # only check these two scripts

Do not submit for marking the output of checking only a few scripts!

  1. When you are done, execute the above Checking Program as a command line on the CLS. This program will check your work, assign you a mark, and display the output on your screen.

    You may run the Checking Program as many times as you wish, allowing you to correct mistakes and get the best mark. Some task sections require you to finish the whole section before running the Checking Program at the end; you may not always be able to run the Checking Program successfully after every single task step.

  2. When you are done with this assignment, and you like the mark displayed on your screen by the Checking Program, you must redirect only the standard output of the Checking Program into the text file assignment12.txt in your Base Directory on the CLS, like this:

    $ ./check >assignment12.txt
    $ less assignment12.txt
    • Use standard output redirection with that exact assignment12.txt file name.
    • Use that exact name. Case (upper/lower case letters) matters.
    • Be absolutely accurate, as if your marks depended on it.
    • Do not edit the output file; the format is fixed.
    • Make sure the file actually contains the output of the Checking Program!
    • The file should contain, near the bottom, a line starting with: YOUR MARK for
    • Really! MAKE SURE THE FILE HAS YOUR MARKS IN IT!
  3. Transfer the above single file assignment12.txt (containing the output from the Checking Program) from the CLS to your local computer.
    • You may want to refer to the File Transfer page for how to transfer the file.
    • Verify that the file still contains all the output from the Checking Program.
    • Do not edit or open and save this file on your local computer! Edited or damaged files will not be marked. Submit the file exactly as given.
    • The file should contain, near the bottom, a line starting with: YOUR MARK for
    • Really! MAKE SURE THE FILE YOU UPLOAD HAS YOUR MARKS IN IT!
  4. Upload the assignment12.txt file from your local computer to the correct Assignment area on Blackboard (with the exact name) before the due date:
    1. On your local computer use a web browser to log in to Blackboard and go to the Blackboard page for this course.
    2. Go to the Blackboard Assignments area for the course, in the left side-bar menu, and find the current assignment.
    3. Under Assignments, click on the underlined assignment12 link for this assignment.
      1. If this is your first upload, the Upload Assignment page will open directly; skip the next sentence.
      2. If you have already uploaded previously, the Review Submission History page will be open and you must use the Start New button at the bottom of the page to get to the Upload Assignment page.
    4. On the Upload Assignment page, scroll down and beside Attach File use Browse My Computer to find and attach your assignment12.txt file from your local computer. Make sure the assignment file has the correct name on your local computer before you attach it. Attach only your assignment12.txt file for upload. Do not attach any other file names.
    5. After you have attached the assignment12.txt file on the Upload Assignment page, scroll down to the bottom of the page and use the Submit button to actually upload your attached assignment12.txt file to Blackboard.
    6. Submit the file exactly as uploaded from the CLS.
    7. Do not submit an empty file. Do not submit any other file names.

    Use only Attach File, Browse My Computer on the Upload Assignment page. Do not enter any text into the Write Submission or Add Comments boxes on Blackboard; I do not read them. Use only the Attach File, Browse My Computer section followed by the Submit button. If you need to comment on any assignment submission, send me EMail.

    You can revise and upload the file more than once using the Start New button on the Review Submission History page to open a new Upload Assignment page. I only look at the most recent submission.

    You must upload the file with the correct name from your local computer; you cannot correct the name as you upload it to Blackboard.

  5. Verify that Blackboard has received your submission: After using the Submit button, you will see a page titled Review Submission History that will show all your uploaded submissions for this assignment. Each of your submissions is called an Attempt on this page. A drop-down list of all your attempts is available.
    1. Verify that your latest Attempt has the correct 16-character, lower-case file name under the SUBMISSION heading.
    2. The one file name must be the only thing under the SUBMISSION heading. Only the one file name is allowed.
    3. No COMMENTS heading should be visible on the page. Do not enter any comments when you upload an assignment.
    4. Click on the Download button to open and view the file you just uploaded. MAKE SURE THE FILE YOU JUST UPLOADED HAS YOUR MARKS IN IT!
    5. Save a screen capture of the Review Submission History page on your local computer, showing the single uploaded file name listed under SUBMISSION. If you want to claim that you uploaded the file and Blackboard lost it, you will need this screen capture to prove that you actually uploaded the file. (To date, Blackboard has never lost an uploaded file.)
    6. Make sure you have used Submit and not Save as Draft. I cannot mark draft assignments. Make sure you Submit.

    You will also see the Review Submission History page any time you already have an assignment attempt uploaded and you click on the underlined assignment12 link. You can use the Start New button on this page to re-upload your assignment as many times as you like.

    You cannot delete an assignment attempt, but you can always upload a new version. I only mark the latest version.

  6. Your instructor may also mark files in your directory in your CLS account after the due date. Leave everything there on the CLS. Do not delete any assignment work from the CLS until after the term is over!

READ ALL THE WORDS. OH PLEASE, PLEASE, PLEASE READ ALL THE WORDS!

Author: 
| Ian! D. Allen, BA, MMath  -  idallen@idallen.ca  -  Ottawa, Ontario, Canada
| Home Page: http://idallen.com/   Contact Improv: http://contactimprov.ca/
| College professor (Free/Libre GNU+Linux) at: http://teaching.idallen.com/
| Defend digital freedom:  http://eff.org/  and have fun:  http://fools.ca/

Plain Text - plain text version of this page in Pandoc Markdown format

Campaign for non-browser-specific HTML   Valid XHTML 1.0 Transitional   Valid CSS!   Creative Commons by nc sa 3.0   Hacker Ideals Emblem   Author Ian! D. Allen